import {
  Body,
  Controller,
  Delete,
  Get,
  Patch,
  Path,
  Post,
  Request,
  Route,
  Security,
  Tags,
  Query
} from "tsoa";
import { AppDataSource } from "../database/data-source";
import HttpSuccess from "../interfaces/http-success";
import HttpStatus from "../interfaces/http-status";
import HttpError from "../interfaces/http-error";
import { ProfileDevelopmentHistory } from "../entities/ProfileDevelopmentHistory";
import { RequestWithUser } from "../middlewares/user";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import {
  CreateProfileEmployeeDevelopment,
  ProfileDevelopment,
  UpdateProfileDevelopment,
} from "../entities/ProfileDevelopment";
import permission from "../interfaces/permission";
import { DevelopmentProject } from "../entities/DevelopmentProject";
import { In, Brackets } from "typeorm";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/development")
@Tags("ProfileDevelopment")
@Security("bearerAuth")
export class ProfileDevelopmentEmployeeController extends Controller {
  private profileRepository = AppDataSource.getRepository(ProfileEmployee);
  private developmentRepository = AppDataSource.getRepository(ProfileDevelopment);
  private developmentHistoryRepository = AppDataSource.getRepository(ProfileDevelopmentHistory);
  private developmentProjectRepository = AppDataSource.getRepository(DevelopmentProject);

  @Get("user")
  public async getDevelopmentUser(@Request() request: RequestWithUser) {
    const profile = await this.profileRepository.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const lists = await this.developmentRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    return new HttpSuccess(lists);
  }

  @Get("{profileId}")
  public async getDevelopment(
    @Path() profileId: string, 
    @Request() req: RequestWithUser,
    @Query("page") page: number = 1,
    @Query("pageSize") pageSize: number = 10,
    @Query() searchKeyword: string = "",
    @Query("sortBy") sortBy?: string,
    @Query("descending") descending?: boolean,
  ) {
    let _workflow = await new permission().Workflow(req, profileId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileId);
    
    let query = await AppDataSource.getRepository(ProfileDevelopment)
      .createQueryBuilder("profileDevelopment")
      .where({ profileEmployeeId: profileId, isDeleted: false })
      .andWhere(
        new Brackets((qb) => {
          qb.where(
            searchKeyword != undefined && searchKeyword != null && searchKeyword != ""
              ? "profileDevelopment.name LIKE :keyword"
              : "1=1",
            {
              keyword: `%${searchKeyword}%`,
            },
          )
            .orWhere(
              searchKeyword != undefined && searchKeyword != null && searchKeyword != ""
                ? "profileDevelopment.developmentTarget LIKE :keyword"
                : "1=1",
              {
                keyword: `%${searchKeyword}%`,
              },
            )
            .orWhere(
              searchKeyword != undefined && searchKeyword != null && searchKeyword != ""
                ? "profileDevelopment.developmentResults LIKE :keyword"
                : "1=1",
              {
                keyword: `%${searchKeyword}%`,
              },
            )
            .orWhere(
              searchKeyword != undefined && searchKeyword != null && searchKeyword != ""
                ? "profileDevelopment.developmentReport LIKE :keyword"
                : "1=1",
              {
                keyword: `%${searchKeyword}%`,
              },
            );
        }),
      )
      .orderBy("profileDevelopment.createdAt", "ASC")
 
      if (sortBy) {
        query = query.orderBy(
          `profileDevelopment.${sortBy}`,
          descending ? "DESC" : "ASC"
        );
      }

      const [profileDevelopment, total] = await query
      .skip((page - 1) * pageSize)
      .take(pageSize)
      .getManyAndCount();

    return new HttpSuccess({ data: profileDevelopment, total });
  }

  @Get("history/{developmentId}")
  public async developmentHistory(@Path() developmentId: string, @Request() req: RequestWithUser) {
    const _record = await this.developmentRepository.findOneBy({ id: developmentId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, developmentId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.developmentHistoryRepository.find({
      where: { profileDevelopmentId: developmentId },
      order: { createdAt: "DESC" },
    });
    return new HttpSuccess(record);
  }

  @Post()
  public async newDevelopment(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeDevelopment,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileId");
    }

    const profile = await this.profileRepository.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);

    const data = new ProfileDevelopment();

    const meta = {
      isDevelopment10: body.isDevelopment10 ?? false,
      isDevelopment20: body.isDevelopment20 ?? false,
      isDevelopment70: body.isDevelopment70 ?? false,
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };

    Object.assign(data, { ...body, ...meta });
    const history = new ProfileDevelopmentHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.developmentRepository.save(data);
    history.profileDevelopmentId = data.id;
    await this.developmentHistoryRepository.save(history);

    if (body.developmentProjects != null) {
      await Promise.all(
        body.developmentProjects.map(async (x) => {
          let developmentProject = new DevelopmentProject();
          let developmentProjectHistory = new DevelopmentProject();
          Object.assign(developmentProject, {
            ...meta,
            name: x,
            profileDevelopmentId: data.id,
          });
          Object.assign(developmentProject, {
            ...meta,
            name: x,
            profileDevelopmentHistoryId: history.id,
          });
          await Promise.all([
            this.developmentProjectRepository.save(developmentProject),
            this.developmentProjectRepository.save(developmentProjectHistory),
          ]);
        }),
      );
    }

    return new HttpSuccess(data.id);
  }

  @Patch("{developmentId}")
  public async editDevelopment(
    @Request() req: RequestWithUser,
    @Body() body: UpdateProfileDevelopment,
    @Path() developmentId: string,
  ) {
    const record = await this.developmentRepository.findOne({
      where: { id: developmentId },
    });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );

    const history = new ProfileDevelopmentHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileDevelopmentId = developmentId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.developmentRepository.save(record),
      this.developmentHistoryRepository.save(history),
    ]);

    await this.developmentProjectRepository.delete({ profileDevelopmentId: record.id });
    if (body.developmentProjects != null) {
      const meta = {
        createdUserId: req.user.sub,
        createdFullName: req.user.name,
        lastUpdateUserId: req.user.sub,
        lastUpdateFullName: req.user.name,
        createdAt: new Date(),
        lastUpdatedAt: new Date(),
      };
      await Promise.all(
        body.developmentProjects.map(async (x) => {
          let developmentProject = new DevelopmentProject();
          let developmentProjectHistory = new DevelopmentProject();
          Object.assign(developmentProject, {
            ...meta,
            name: x,
            profileDevelopmentId: record.id,
          });
          Object.assign(developmentProject, {
            ...meta,
            name: x,
            profileDevelopmentHistoryId: history.id,
          });
          await Promise.all([
            this.developmentProjectRepository.save(developmentProject),
            this.developmentProjectRepository.save(developmentProjectHistory),
          ]);
        }),
      );
    }

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลการพัฒนารายบุคคล IDP
   * @summary API ลบข้อมูลการพัฒนารายบุคคล IDP
   * @param developmentId คีย์การพัฒนารายบุคคล IDP
   */
  @Patch("update-delete/{developmentId}")
  public async updateIsDeletedTraining(
    @Request() req: RequestWithUser,
    @Path() developmentId: string,
  ) {
    const record = await this.developmentRepository.findOneBy({ id: developmentId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileDevelopmentHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.developmentRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.developmentHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{developmentId}")
  public async deleteDevelopment(@Path() developmentId: string, @Request() req: RequestWithUser) {
    const _record = await this.developmentRepository.findOneBy({ id: developmentId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }

    await this.developmentHistoryRepository.delete({
      profileDevelopmentId: developmentId,
    });

    const result = await this.developmentRepository.delete({ id: developmentId });

    if (result.affected == undefined || result.affected <= 0) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess();
  }
}
